org.apache.poi.ss.formula.ptg

## Class AttrPtg

- java.lang.Object
- - org.apache.poi.ss.formula.ptg.Ptg
  - - org.apache.poi.ss.formula.ptg.ControlPtg
    - - org.apache.poi.ss.formula.ptg.AttrPtg

- All Implemented Interfaces:
    Duplicatable

      public final class AttrPtg
      extends ControlPtg

  "Special Attributes"

  This seems to be a Misc Stuff and Junk record. One function it serves is in SUM functions (i.e. SUM(A1:A3) causes an area PTG then an ATTR with the SUM option set)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `AttrPtg.SpaceType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static byte` | `sid`
    `static AttrPtg` | `SUM`

    - ### Fields inherited from class org.apache.poi.ss.formula.ptg.Ptg

      `CLASS_ARRAY, CLASS_REF, CLASS_VALUE, EMPTY_PTG_ARRAY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AttrPtg(LittleEndianInput in)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AttrPtg` | `copy()`
    `static AttrPtg` | `createIf(int dist)`
    `static AttrPtg` | `createSkip(int dist)`
    `static AttrPtg` | `createSpace(int type, int count)`
    `int` | `getChooseFuncOffset()`
    `short` | `getData()`
    `int[]` | `getJumpTable()`
    `int` | `getNumberOfOperands()`
    `int` | `getSize()`
    `static AttrPtg` | `getSumSingle()`
    `int` | `getType()`
    `boolean` | `isOptimizedChoose()`
    `boolean` | `isOptimizedIf()`
    `boolean` | `isSemiVolatile()`
    `boolean` | `isSkip()`
    `boolean` | `isSpace()`
    `boolean` | `isSum()`
    `java.lang.String` | `toFormulaString()` return a string representation of this token alone
    `java.lang.String` | `toFormulaString(java.lang.String[] operands)`
    `java.lang.String` | `toString()` Overridden toString method to ensure object hash is not printed.
    `void` | `write(LittleEndianOutput out)`

    - ### Methods inherited from class org.apache.poi.ss.formula.ptg.ControlPtg

      `getDefaultOperandClass, isBaseToken`

    - ### Methods inherited from class org.apache.poi.ss.formula.ptg.Ptg

      `createPtg, doesFormulaReferToDeletedCell, getEncodedSize, getEncodedSizeWithoutArrayData, getPtgClass, getRVAType, readTokens, serializePtgs, setClass`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### sid

          public static final byte sid

      See Also:
        Constant Field Values

    - #### SUM

          public static final AttrPtg SUM

  - ### Constructor Detail

    - #### AttrPtg

          public AttrPtg(LittleEndianInput in)

  - ### Method Detail

    - #### createSpace

          public static AttrPtg createSpace(int type,
                                            int count)

      Parameters:
        `type` - a constant from `SpaceType`
        `count` - the number of space characters

    - #### createIf

          public static AttrPtg createIf(int dist)

      Parameters:
        `dist` - distance (in bytes) to start of either
        - false parameter
        - tFuncVar(IF) token (when false parameter is not present)

    - #### createSkip

          public static AttrPtg createSkip(int dist)

      Parameters:
        `dist` - distance (in bytes) to position behind tFuncVar(IF) token (minus 1)

    - #### getSumSingle

          public static AttrPtg getSumSingle()

    - #### isSemiVolatile

          public boolean isSemiVolatile()

    - #### isOptimizedIf

          public boolean isOptimizedIf()

    - #### isOptimizedChoose

          public boolean isOptimizedChoose()

    - #### isSum

          public boolean isSum()

    - #### isSkip

          public boolean isSkip()

    - #### isSpace

          public boolean isSpace()

    - #### getData

          public short getData()

    - #### getJumpTable

          public int[] getJumpTable()

    - #### getChooseFuncOffset

          public int getChooseFuncOffset()

    - #### toString

          public java.lang.String toString()

      Description copied from class: `Ptg`
      Overridden toString method to ensure object hash is not printed. This helps get rid of gratuitous diffs when comparing two dumps Subclasses may output more relevant information by overriding this method
      Overrides:
        `toString` in class `Ptg`

    - #### write

          public void write(LittleEndianOutput out)

      Specified by:
        `write` in class `Ptg`

    - #### getSize

          public int getSize()

      Specified by:
        `getSize` in class `Ptg`
      Returns:
        the encoded length of this Ptg, including the initial Ptg type identifier byte.

    - #### toFormulaString

          public java.lang.String toFormulaString(java.lang.String[] operands)

    - #### getNumberOfOperands

          public int getNumberOfOperands()

    - #### getType

          public int getType()

    - #### toFormulaString

          public java.lang.String toFormulaString()

      Description copied from class: `Ptg`
      return a string representation of this token alone
      Specified by:
        `toFormulaString` in class `Ptg`

    - #### copy

          public AttrPtg copy()

      Specified by:
        `copy` in interface `Duplicatable`
      Specified by:
        `copy` in class `Ptg`
      Returns:
        a deep copy of the implementing class / instance

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.